<?php
/**
 * @file
 * Administrative page callbacks for the Sourcepoint module.
 */

/**
 * Implements hook_admin_settings() for module settings configuration.
 */
function sourcepoint_admin_settings_form($form, &$form_state) {
  // Global options.
  $form['sourcepoint_enabled'] = array(
    '#type' => 'checkbox',
    '#title' => t('v1 Enabled'),
    '#default_value' => variable_get('sourcepoint_enabled', 0),
    '#description' => t('Global kill switch.'),
  );

  $form['sourcepoint_enabled_v2'] = array(
    '#type' => 'checkbox',
    '#title' => t('v2 Enabled'),
    '#default_value' => variable_get('sourcepoint_enabled_v2', 0),
    '#description' => t('Global kill switch.'),
  );

  $form['sourcepoint_v2'] = array(
    '#type' => 'fieldset',
    '#title' => t('Sourcepoint v2'),
  );
  $form['sourcepoint_v2']['sourcepoint_account_id_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('Sourcepoint v2 Account ID'),
    '#default_value' => variable_get('sourcepoint_account_id_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['sourcepoint_base_endpoint_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('Sourcepoint v2 baseEndpoint'),
    '#default_value' => variable_get('sourcepoint_base_endpoint_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['sourcepoint_privacy_manager_id_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('Privacy manager ID'),
    '#default_value' => variable_get('sourcepoint_privacy_manager_id_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['sourcepoint_script_weight_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('Sourcepoint v2 script weight'),
    '#default_value' => variable_get('sourcepoint_script_weight_v2', '-10'),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['sourcepoint_v2_events'] = array(
    '#type' => 'textarea',
    '#title' => t('Sourcepoint v2 events'),
    '#default_value' => variable_get('sourcepoint_v2_events', ''),
    '#size' => 500,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['amp'] = array(
    '#type' => 'fieldset',
    '#title' => t('Sourcepoint v2 AMP'),
  );
  $form['sourcepoint_v2']['amp']['sourcepoint_enable_amp_v2'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable sourcepoint for AMP'),
    '#default_value' => variable_get('sourcepoint_enable_amp_v2', ''),
    '#description' => t('Enable sourcepoint for AMP.'),
  );
  $form['sourcepoint_v2']['amp']['sourcepoint_mms_domain_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('mms domain for AMP'),
    '#default_value' => variable_get('sourcepoint_mms_domain_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['amp']['sourcepoint_property_id_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('Property ID for AMP'),
    '#default_value' => variable_get('sourcepoint_property_id_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['amp']['sourcepoint_privacy_manager_amp_id_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('Privacy manager ID for AMP'),
    '#default_value' => variable_get('sourcepoint_privacy_manager_amp_id_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['amp']['sourcepoint_propertyhref_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('Propertyhref for AMP'),
    '#default_value' => variable_get('sourcepoint_propertyhref_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['amp']['sourcepoint_checkConsentHref_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('checkConsentHref for AMP'),
    '#default_value' => variable_get('sourcepoint_checkConsentHref_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v2']['amp']['sourcepoint_promptUISrc_v2'] = array(
    '#type' => 'textfield',
    '#title' => t('promptUISrc for AMP'),
    '#default_value' => variable_get('sourcepoint_promptUISrc_v2', ''),
    '#size' => 20,
    '#required' => FALSE,
  );


  $form['sourcepoint_v1'] = array(
    '#type' => 'fieldset',
    '#title' => t('Sourcepoint v1'),
  );
  $form['sourcepoint_v1']['sourcepoint_account_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Sourcepoint v1 Account ID'),
    '#default_value' => variable_get('sourcepoint_account_id', ''),
    '#size' => 20,
    '#required' => FALSE,
  );
  $form['sourcepoint_v1']['sourcepoint_mms_domain'] = array(
    '#type' => 'textfield',
    '#title' => t('MMS Domain'),
    '#default_value' => variable_get('sourcepoint_mms_domain', ''),
    '#size' => 50,
    '#description' => t('The Url of the MMS domain'),
  );

  // Content Control.
  $form['sourcepoint_v1']['content_control'] = array(
    '#type' => 'fieldset',
    '#title' => t('Content Control'),
  );
  $form['sourcepoint_v1']['content_control']['sourcepoint_rid_enabled'] = array(
    '#type' => 'checkbox',
    '#title' => t('RID Enabled'),
    '#default_value' => variable_get('sourcepoint_rid_enabled', 1),
    '#description' => t('Enable Recovery Interference Detection.'),
  );
  $form['sourcepoint_v1']['content_control']['sourcepoint_content_control_url'] = array(
    '#type' => 'textfield',
    '#title' => t('Content Control landing page'),
    '#default_value' => variable_get('sourcepoint_content_control_url', ''),
    '#size' => 50,
    '#description' => t('The Url of the landing page. i.e. http://www.example.com/page'),
  );

  // Consent Management Platform.
  $form['sourcepoint_v1']['cmp'] = array(
    '#type' => 'fieldset',
    '#title' => t('Consent Management Platform'),
  );
  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_enabled'] = array(
    '#type' => 'checkbox',
    '#title' => t('CMP Enabled'),
    '#default_value' => variable_get('sourcepoint_cmp_enabled', 1),
    '#description' => t('Enable Consent Management Platform.'),
  );
  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_site_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Site ID'),
    '#default_value' => variable_get('sourcepoint_cmp_site_id', ''),
    '#size' => 50,
    '#description' => t('Site ID for privacy manager.'),
    '#element_validate' => array('element_validate_integer_positive')
  );
  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_privacy_manager_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Privacy Manager ID'),
    '#default_value' => variable_get('sourcepoint_cmp_privacy_manager_id', ''),
    '#size' => 50,
    '#description' => t('Privacy Manager ID.'),
  );
  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_overlay_height'] = array(
    '#type' => 'textfield',
    '#title' => t('Overlay Height'),
    '#default_value' => variable_get('sourcepoint_cmp_overlay_height', '600px'),
    '#size' => 50,
    '#description' => t('Height of the overlay iframe.'),
  );
  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_overlay_width'] = array(
    '#type' => 'textfield',
    '#title' => t('Overlay Width'),
    '#default_value' => variable_get('sourcepoint_cmp_overlay_width', '600px'),
    '#size' => 50,
    '#description' => t('Width of the overlay iframe.'),
  );
  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_shim_script'] = array(
    '#type' => 'textfield',
    '#title' => t('cmp shim script url'),
    '#default_value' => variable_get('sourcepoint_cmp_shim_script', ''),
    '#size' => 100,
    '#description' => t('URL of the cmp shim script.'),
  );
  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_shim_async'] = array(
    '#type' => 'checkbox',
    '#title' => t('run cmp shim script as async'),
    '#default_value' => variable_get('sourcepoint_cmp_shim_async', ''),
    '#description' => t('make cmp shim script run asynchronously.'),
  );

  $form['sourcepoint_v1']['cmp']['sourcepoint_cmp_waitForConsentData'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enable waitForConsentData'),
    '#default_value' => variable_get('sourcepoint_cmp_waitForConsentData', 0),
    '#description' => t('Will set waitForConsentData to true.'),
  );

  // Overlay iframe.
  if ($url = sourcepoint_get_privacy_manager_url()) {
    $messages = array();
    $messages[] = t('<h2>Privacy Manager</h2>URL: !url', array(
      '!url' => l($url, $url, array('attributes' => array('class' => 'sourcepoint-cmp-overlay'))),
    ));
    $messages[] = t('Add :class class to links to open overlay.', array(':class' => '.sourcepoint-cmp-overlay'));
    $messages[] = t('Use :menu_link to open the overlay from menu items.', array(':menu_link' => '<sourcepoint_cmp_overlay>'));

    $form['cmp']['sourcepoint_cmp_overlay_demo_url'] = array(
      '#theme' => 'item_list',
      '#items' => $messages,
    );
    $form['cmp']['sourcepoint_cmp_overlay_demo'] = sourcepoint_get_privacy_manager_overlay();
  }

  // Detection Timeout Management.
  $form['sourcepoint_v1']['detection'] = array(
    '#type' => 'fieldset',
    '#title' => t('Detection Timeout Management'),
  );

  $form['sourcepoint_v1']['detection']['sourcepoint_dtm_enabled'] = array(
    '#type' => 'checkbox',
    '#title' => t('Enabled'),
    '#default_value' => variable_get('sourcepoint_dtm_enabled', 1),
    '#description' => t('Enable detection timeout.'),
  );
  $form['sourcepoint_v1']['detection']['sourcepoint_dtm_timeout'] = array(
    '#type' => 'textfield',
    '#title' => t('Timeout'),
    '#default_value' => variable_get('sourcepoint_dtm_timeout', 500),
    '#description' => t('Detection timeout in milliseconds.'),
    '#element_validate' => array('element_validate_integer_positive')
  );

  // Style Manager
  $form['sourcepoint_v1']['style_manager'] = array(
    '#type' => 'fieldset',
    '#title' => t('Style Manager'),
  );
  $form['sourcepoint_v1']['style_manager']['sourcepoint_style_manager'] = array(
    '#type' => 'checkbox',
    '#title' => t('Style Manager Enabled'),
    '#default_value' => variable_get('sourcepoint_style_manager', 1),
    '#description' => t('Enable Style Manager'),
  );

  return system_settings_form($form);
}
